/*
 * Created on Jul 26, 2005
 *
 */
package se.umu.jobsubmission.impl.informationfinder;

import java.util.Calendar; 
import org.globus.mds.glue.GLUECERPType;

/**
 * @author tordsson
 *
 * An entry in the map storing cached resource information, 
 * contains the info, and a timestamp telling when the stored
 * information expires. 
 */
public class CachedResourceInformation {
	
	private Calendar timestamp; 
	private GLUECERPType information; 

	/**
	 * @param timestamp
	 * @param information
	 */
	public CachedResourceInformation(Calendar timestamp,
			GLUECERPType information) {
		super();
		this.timestamp = timestamp;
		this.information = information;
	}
	

	/**
	 * @return Returns the information.
	 */
	public GLUECERPType getInformation() {
		return information;
	}
	/**
	 * @param information The information to set.
	 */
	public void setInformation(GLUECERPType information) {
		this.information = information;
	}
	/**
	 * @return Returns the timestamp.
	 */
	public Calendar getTimestamp() {
		return timestamp;
	}
	/**
	 * @param timestamp The timestamp to set.
	 */
	public void setTimestamp(Calendar timestamp) {
		this.timestamp = timestamp;
	}
}
