/*
 * Created on Apr 22, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.wsag.impl;

import org.apache.axis.message.MessageElement;
import org.ggf.ws_agreement.AgreementType;
import org.ggf.ws_agreement.ServiceDescriptionTermType;
import org.ggf.ws_agreement.TermCompositorType;
import org.ggf.ws_agreement.TermTreeType;
import org.globus.wsrf.encoding.ObjectDeserializer;
import org.globus.wsrf.utils.AnyHelper;

import se.umu.reservation.LocalReservation;
import se.umu.reservation.ReservationDescriptionType;
import se.umu.reservation.ReservationType;

/**
 * @author tordsson
 *
 * Sets up ServiceDescriptionTerms for reservations, 
 * included are all the parameters from the request 
 * (#CPUs, duration, earliestStart, latestStart, flexible) 
 * as well as information regarding the local reservation 
 * (localID, exactStart, committed)
 * All these are stored in a ReservationType 
 * (Since we due to bug Axis 15789 can have only one 
 * ServiceDescriptionTerm in the RP document) 
 */
public class ReservationResourceHelper 
	implements AgreementResourceHelper {

	public TermTreeType createTerms(AgreementType offer, Object context) {
		
		try {
			
			// Extract the ReservationDescriptionType
			TermTreeType offerTerms = offer.getTerms();
			TermCompositorType offerAll = offerTerms.getAll(); 
			ServiceDescriptionTermType term = offerAll.
			getServiceDescriptionTerm();							
			MessageElement any[] = term.get_any(); 			
			ReservationDescriptionType reservationOffer = 
				(ReservationDescriptionType) ObjectDeserializer.
				toObject(any[0], ReservationDescriptionType.class);
			
			// Extract information about local reservation from context 
			LocalReservation localReservation = (LocalReservation) context;
			
			// Create ReservationTerms and add all information to it. 
			ReservationType reservationTerms = new ReservationType();
			
			reservationTerms.setCommitted(localReservation.getCommitted()); 
			reservationTerms.setExactStart(localReservation.getExactStart()); 
			reservationTerms.setLocalID(localReservation.getLocalID());
			
			reservationTerms.setDuration(reservationOffer.getDuration());
			reservationTerms.setFlexible(reservationOffer.getFlexible());
			reservationTerms.setNumberOfCPUs(reservationOffer.
					getNumberOfCPUs());
			
			// These two must be extracted from guaranteeTerms...
			// reservationTerms.setEarliestStart(null);
			// reservationTerms.setLatestStart(null); 
			
			// Serialize ReservationType and add is as the
			// ServiceDescriptionTerm in RP... 
			ServiceDescriptionTermType agreementTerms = 
				new ServiceDescriptionTermType();
			MessageElement agreementAny[] = AnyHelper.toAnyArray(
					reservationTerms); 			   
			agreementTerms.set_any(agreementAny);
			TermCompositorType all = new TermCompositorType(); 
			all.setServiceDescriptionTerm(agreementTerms);
			
			// Keep GuaranteeTerms as they are for now. 
			all.setGuaranteeTerm(offerAll.getGuaranteeTerm()); 
			
			TermTreeType terms = new TermTreeType();
			terms.setAll(all); 
			return terms; 
		
		} catch (Exception e) {
			return null; 
		}
		
	}

}
